package com.ozacc.mail;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;

/**
 * ᡼롣
 * 
 * @author Tomohiro Otsuka
 * @version $Id$
 */
public class Mail {

	/** ISO-2022-JP */
	public static final String JIS_CHARSET = "ISO-2022-JP";

	private String text;

	private InternetAddress from;

	private String subject;

	private List to;

	private List cc;

	private List bcc;

	private InternetAddress returnPath;

	private InternetAddress replyTo;

	private String importance;

	private Map xHeaders;

	/**
	 * 󥹥ȥ饯
	 */
	public Mail() {}

	/**
	 * ᡼ν٤򥻥åȤޤ
	 * ǻǽͤϡhighסnormalסlowפΤ줫Ǥ
	 * 
	 * @param importance ᡼ν١highסnormalסlowפΤ줫
	 * 
	 * @see Mail.Importance
	 */
	public void setImportance(String importance) {
		if ("high".equals(importance) || "normal".equals(importance) || "low".equals(importance)) {
			this.importance = importance;
		} else {
			throw new IllegalArgumentException("'" + importance + "'ϡ᡼٤ˤϻǤʤͤǤ");
		}
	}

	/**
	 * ᡼ν٤֤ޤ
	 * ͤϡhighסnormalסlowפΤ줫Ǥ
	 * 
	 * @return ᡼ν١highסnormalסlowפΤ줫
	 */
	public String getImportance() {
		return importance;
	}

	/**
	 * ᡼襢ɥ쥹ɲäޤ
	 * 
	 * @param email 襢ɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void addTo(String email) throws IllegalArgumentException {
		if (to == null) {
			to = new ArrayList();
		}
		try {
			to.add(new InternetAddress(email));
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼̾ȥɥ쥹ɲäޤ
	 * ̾JIS_CHARSETǥ󥳡ɤޤ
	 * 
	 * @param email 襢ɥ쥹
	 * @param name ̾
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void addTo(String email, String name) throws IllegalArgumentException {
		if (to == null) {
			to = new ArrayList();
		}
		try {
			to.add(new InternetAddress(email, name, JIS_CHARSET));
		} catch (UnsupportedEncodingException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼襢ɥ쥹֤ޤ
	 * 襢ɥ쥹⥻åȤƤʤȤ϶֤ޤ
	 * 
	 * @return 襢ɥ쥹
	 */
	public InternetAddress[] getTo() {
		if (to == null) {
			return new InternetAddress[0];
		}
		return (InternetAddress[])to.toArray(new InternetAddress[to.size()]);
	}

	/**
	 * CCΥɥ쥹ɲäޤ
	 * 
	 * @param email CCΥɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void addCc(String email) throws IllegalArgumentException {
		if (cc == null) {
			cc = new ArrayList();
		}
		try {
			cc.add(new InternetAddress(email));
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * CCΰ̾ȥɥ쥹ɲäޤ
	 * ̾JIS_CHARSETǥ󥳡ɤޤ
	 * 
	 * @param email CCΥɥ쥹
	 * @param name CCΰ̾
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void addCc(String email, String name) throws IllegalArgumentException {
		if (cc == null) {
			cc = new ArrayList();
		}
		try {
			cc.add(new InternetAddress(email, name, JIS_CHARSET));
		} catch (UnsupportedEncodingException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼CCɥ쥹֤ޤ
	 * CCɥ쥹⥻åȤƤʤȤ϶֤ޤ
	 * 
	 * @return CCɥ쥹
	 */
	public InternetAddress[] getCc() {
		if (cc == null) {
			return new InternetAddress[0];
		}
		return (InternetAddress[])cc.toArray(new InternetAddress[cc.size()]);
	}

	/**
	 * BCCΥɥ쥹ɲäޤ
	 * 
	 * @param email BCCΥɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void addBcc(String email) throws IllegalArgumentException {
		if (bcc == null) {
			bcc = new ArrayList();
		}
		try {
			bcc.add(new InternetAddress(email));
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼BCCɥ쥹֤ޤ
	 * BCCɥ쥹⥻åȤƤʤȤ϶֤ޤ
	 * 
	 * @return BCCɥ쥹
	 */
	public InternetAddress[] getBcc() {
		if (bcc == null) {
			return new InternetAddress[0];
		}
		return (InternetAddress[])bcc.toArray(new InternetAddress[bcc.size()]);
	}

	/**
	 * ᡼κпͥɥ쥹򥻥åȤޤ
	 * 
	 * @param email пͥɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void setFrom(String email) throws IllegalArgumentException {
		try {
			from = new InternetAddress(email);
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼κп̾ȥɥ쥹򥻥åȤޤ
	 * ̾JIS_CHARSETǥ󥳡ɤޤ
	 * 
	 * @param email пͥɥ쥹
	 * @param name п̾
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void setFrom(String email, String name) throws IllegalArgumentException {
		try {
			from = new InternetAddress(email, name, JIS_CHARSET);
		} catch (UnsupportedEncodingException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼κпͥɥ쥹֤ޤåȤƤʤnull֤ޤ
	 * 
	 * @return ᡼κпͥɥ쥹
	 */
	public InternetAddress getFrom() {
		return from;
	}

	/**
	 * Return-Pathɥ쥹򥻥åȤޤ
	 * 
	 * @param email Return-Pathɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void setReturnPath(String email) throws IllegalArgumentException {
		try {
			returnPath = new InternetAddress(email);
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * Return-Pathɥ쥹֤ޤ
	 * 
	 * @return Return-Pathɥ쥹
	 */
	public InternetAddress getReturnPath() {
		return returnPath;
	}

	/**
	 * ֿ襢ɥ쥹򥻥åȤޤ
	 * 
	 * @param email ֿ襢ɥ쥹
	 * @throws IllegalArgumentException ʥեޥåȤΥɥ쥹ꤵ줿
	 */
	public void setReplyTo(String email) throws IllegalArgumentException {
		try {
			replyTo = new InternetAddress(email);
		} catch (AddressException e) {
			throw new IllegalArgumentException(e.getMessage());
		}
	}

	/**
	 * ᡼ֿ襢ɥ쥹֤ޤåȤƤʤnull֤ޤ
	 * 
	 * @return ֿ襢ɥ쥹
	 */
	public InternetAddress getReplyTo() {
		return replyTo;
	}

	/**
	 * ᡼η֤̾ޤåȤƤʤ϶ʸ֤ޤ
	 * 
	 * @return ᡼η̾
	 */
	public String getSubject() {
		if (subject == null) {
			return "";
		}
		return subject;
	}

	/**
	 * ᡼η̾򥻥åȤޤ
	 * 
	 * @param subject ᡼η̾
	 */
	public void setSubject(String subject) {
		this.subject = subject;
	}

	/**
	 * ᡼ʸ֤ޤ
	 * ʸåȤƤʤ϶ʸ֤ޤ
	 * 
	 * @return ᡼ʸ
	 */
	public String getText() {
		if (text == null) {
			return "";
		}
		return text;
	}

	/**
	 * ᡼ʸ򥻥åȤޤ
	 * 
	 * @param text ᡼ʸ
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * ᡼إåǤդΥإåɲäޤ
	 * ǤեإåϡX-key: valueפΥեޥåȤǥ᡼إåȤ߹ޤޤ
	 *  
	 * @param key Ǥեإå̾Ƭ"X-"ǻϤޤäƤʤСưŪͿޤ
	 * @param value Ǥեإå
	 */
	public void addXHeader(String key, String value) {
		if (xHeaders == null) {
			xHeaders = new HashMap();
		}
		if (key.startsWith("X-")) {
			xHeaders.put(key, value);
		} else {
			xHeaders.put("X-" + key, value);
		}
	}

	/**
	 * ᡼Ǥեإå̾ͤMap󥹥󥹤֤ޤ
	 * Ǥեإå⥻åȤƤʤȤnull֤ޤ
	 * <p>
	 * Map󥹥󥹤ؤνϤǤޤ(unmodifiableMapˤʤäƤޤ)
	 * 
	 * @return ᡼Ǥեإå̾ͤMap󥹥󥹡ޤnull
	 */
	public Map getXHeaders() {
		if (xHeaders == null) {
			return null;
		}
		return Collections.unmodifiableMap(xHeaders);
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer("Mail: ");
		sb.append("from=").append(this.from == null ? "null" : this.from.toUnicodeString()).append("; ");
		sb.append("replyTo=").append(this.replyTo == null ? "null" : this.replyTo.toUnicodeString()).append("; ");
		sb.append("to=").append(arrayToCommaDelimitedString(this.to)).append("; ");
		sb.append("cc=").append(arrayToCommaDelimitedString(this.cc)).append("; ");
		sb.append("bcc=").append(arrayToCommaDelimitedString(this.bcc)).append("; ");
		sb.append("subject=").append(this.subject).append("; ");
		sb.append("text=").append(this.text);
		return sb.toString();
	}

	/**
	 * @param list
	 * @return 
	 */
	private String arrayToCommaDelimitedString(List list) {
		if (list == null) {
			return "null";
		} else {
			StringBuffer sb = new StringBuffer();
			for (int i = 0, num = list.size(); i < num; i++) {
				if (i > 0) {
					sb.append(", ");
				}
				sb.append(((InternetAddress)list.get(i)).toUnicodeString());
			}
			return sb.toString();
		}
	}

	/**
	 * ᡼ν١
	 * 
	 * @author Tomohiro Otsuka
	 * @version $Id$
	 */
	public static class Importance {

		/** ١ֹ */
		public static final String HIGH = "high";

		/** ١ */
		public static final String NORMAL = "normal";

		/** ١ */
		public static final String LOW = "low";
	}
}